jQuery(document).ready(function (jQuery) {
    // Declara $ para evitar conflito
    $ = jQuery;
    // Scripts que são necessários estarem carregados na página
    var scripts = [
        "../libraries/noboss/assets/plugins/js/min/jquery-confirm.min.js",
        "../libraries/noboss/assets/plugins/stylesheets/css/jquery-confirm.min.css",
    ];
    // Carrega os scripts que ainda não estão na página
    var queue = scripts.map(function (script) {
        if (script.slice(-2) === 'js' && jQuery("script[src*='" + script.slice(-30) + "']").length === 0) {
            return jQuery("head").append('<script type="text/javascript" src="' + script + '"></script>');
        } else if (script.slice(-3) === 'css' && jQuery("link[href*='" + script.slice(-30) + "']").length === 0) {
            return jQuery("head").append('<link rel="stylesheet" href="' + script + '"/>');
        }
    });
    // Todos scripts necessário estão carregados
    jQuery.when.apply(null, queue).done(function () {
        nobossCalendarSubform.CONSTRUCTOR();
    });
});

var nobossCalendarSubform = {};

nobossCalendarSubform.CONSTRUCTOR = function () {
    // variavel que vai servir para gerar um index unico para cada evento, para nao ocorrer sobreescrita de posicoes do array de controle
    nobossCalendarSubform.controlCounter = 0;
    // Declara array de controle de eventos a serem removidos (que forem clicados em remover no subform e que existam no banco de dados)
    nobossCalendarSubform.eventsToRemove = [];
    // ativa evento de alteracao nos filtros de ano ou mes
    nobossCalendarSubform.addFilterListener();
    // se ja tem um tema selecionado
    if (jQuery('[data-id="theme-modal-input"]').val()) {
        // guarda o json contendo todos os itens no array de controle
        nobossCalendarSubform.updateControlArray();
        // remove o input hidden colocado pelo subform do joomla
        jQuery('[name="jform\\[params\\]\\[' + jQuery('[data-id="theme-modal-input"]').val() + '\\]"][data-id!="calendar-input-hidden"]').remove();
        
        /* TODO: Se formos reativar opcao do mes vir selecionado, eh preciso ajustar o codigo comentado abaixo
         *              - Uma ideia seria ter um parametro para deixar o usuario selecionar
         *              - Se tirar o mes corrente selecionado, eh preciso:
         *                  * Comentar o codigo abaixo que adiciona o loader
         *                  * Comentar o setTimeout mais abaixo
         *                  * Remover no arquivo fields nobosssubformcalendar.php os codigos que trazem o mes corrente selecionado
         */
        // Adiciona loader durante carregamento dos dados (se ja nao estiver exibido)
        // if (jQuery("div.loader--fullpage").length == 0){
        //     jQuery('body').append('<div class="loader loader--fullpage"></div>');
        //     jQuery('body').append('<div class="loader-fade"></div>');
        // }
    }

    // Evento de troca de tema
    jQuery('body').on('change', '[data-id="theme-modal-input"]', function () {
        // reativa evento de alteracao nos filtros de ano ou mes
        nobossCalendarSubform.addFilterListener();
        // zera a variavel de controle dos index do array
        nobossCalendarSubform.controlCounter = 0;
        // atualiza o json contendo todos os itens no array de contle
        nobossCalendarSubform.updateControlArray();
        // remove o input hidden colocado pelo subform do joomla
        jQuery('[name="jform\\[params\\]\\[' + jQuery('[data-id="theme-modal-input"]').val() + '\\]"][data-id!="calendar-input-hidden"]').remove();

        // Remove todos eventos do subform que estiverem sendo exibidos na pagina para evitar problemas de required com campos
        jQuery('body').find('#attrib-items .subform-repeatable-group[data-base-name]').remove();

        // Salva a pagina (fizemos isso pq recarregando a pagina com o salvar, impede que ocorra problema de campos com required das datas no subform)
        Joomla.submitbutton('module.apply');
    });
    
    setTimeout(function () {
        // Aplica evento change no campo de mes correspondente ao subform que esta sendo exibido (para trazer o mes corrente selecionado)
        jQuery('[data-id="items-filter"][data-theme="' + jQuery('[data-id="theme-modal-input"]').val() + '"]').find('[data-id="month-filter"]').trigger('change');
    }, 500);

    // Evento para quando usuario clicar para duplicar um item do subform
    jQuery(document).on('click', '[data-bt="duplicate-item"]', function () {
        // Executa funcao que fara o clone
        nobossCalendarSubform.cloneEvent(jQuery(this));
    });
};

// Evento de novo item de subform adicionado
jQuery(document).on('subform-row-add', function (event, row) {
    // Ativa eventos que alteram required's de campos de data conforme opcao de recorrencia escolhida
    nobossCalendarSubform.changeRequiredDateFields(jQuery(row));
});

/**
 * Ativa evento change para os filtros de eventos
 */
nobossCalendarSubform.addFilterListener = function(){
    jQuery('[data-id="items-filter"]').on('change', '[data-id="month-filter"], [data-id="year-filter"]', nobossCalendarSubform.applyFilter);
};

/**
 * Intercepta o save do Joomla para atualizar o valor do input hidden com um json contendo todos os eventos
 */
nobossCalendarSubform.interceptSave = function(){
    // Adiciona loader durante carregamento dos dados (se ja nao estiver exibido)
    if (jQuery("div.loader--fullpage").length == 0){
        jQuery('body').append('<div class="loader loader--fullpage"></div>');
        jQuery('body').append('<div class="loader-fade"></div>');
    }

    // Obtem o modelo de tema
    var theme = jQuery('[data-id="theme-modal-input"]').val();

    // verifica se um tema foi escolhido
    if(theme !== ""){
        // pega o subform de itens vinculado ao tema escolhido
        var subform = jQuery('[data-id="items-filter"][data-theme="' + theme + '"]').siblings('.row-fluid[data-subform-collapse-wrapper]').first();

        // adiciona itens sendo exibidos ao array de controle
        nobossCalendarSubform.addItemsToArray(subform);
        // pega o input hidden que contem o json de todos os eventos
        var inputHidden = jQuery('[data-id="calendar-input-hidden"][data-theme="' + theme + '"]');
        // valor a ser inserido no inpup hidden, que eh o que o joomla deve salvar, comeca vazio
        var inputHiddenValue = "";

        // Salva os dados convertendo primeiro para objeto somente de valores (para retirar indices iniciais que nao tem valores) e depois converte para json
        inputHiddenValue = JSON.stringify(Object.values(nobossCalendarSubform.hiddenValue))

        // Garante que o input hidden dos eventos seja salvo vazio para nao manter dados desneecssarios salvos
        inputHidden.val('');

        // Obtem trecho da url que informa o id do modulo
        var idModule = window.location.href.split("id=");
        
        // Parametro id definido
        if (((idModule.length) > 1) && idModule[1] != 0 && idModule[1] != ''){
            // Obtem o id especificamente
            idModule = idModule[1].split("&")[0];
        }
        // Parametro nao definido: eh um novo registro
        else{
            idModule = 0;
        }

        var error = false;

        // Obtem id do calendario (que eh gerado randomicamente)
        var idCalendar = jQuery('input[name$="\\[id_calendar\\]"]').val();

        // Monta a url de requisição
        var request = {
            'option': 'com_ajax',
            'module': 'nobosscalendar',
            'method': 'saveEvents',
            'format': 'raw',
            'lang': lang
        };
        // Monta os dados a serem enviados
        var data = {
            'data_json': inputHiddenValue,
            'id_module': idModule,
            'id_calendar': idCalendar,
            'events_to_remove': nobossCalendarSubform.eventsToRemove
        };

        // Executa requisicao ajax
        jQuery.ajax({
            url: baseNameUrl+ "?" + jQuery.param(request),
            type: "POST",
            dataType: 'JSON',
            async: false,
            data: data
        }).done(function (result) {
            // Se retorno nao estiver definido, nao faz nada
            if (result == undefined){

            }
            // Ocorreu um erro: exibe mensagem e retorna false para que formulario nao seja submetido
            else if (result.success == 0){
                // Exibe um alerta avisando que teve erro de conexão e não foi possivel obter o plano da extensão
                jQuery.alert({
                    title: 'Error',
                    content: result.message,
                    type: 'red',
                    buttons: {
                        ok: {
                            keys: ['enter']
                        }
                    }
                });

                // Remove loader
                jQuery('body').find('.loader.loader--fullpage').remove();
                jQuery('body').find('.loader-fade').remove();
                error = true;
            }
        });
    }

    if (error == true){
        return false;
    }
    
    return true;
};

/**
 * Atualiza o array de controle buscando os eventos
 */
nobossCalendarSubform.updateControlArray = function () {
    // Obtem id do calendario (que eh gerado randomicamente)
    var idCalendar = jQuery('input[name$="\\[id_calendar\\]"]').val();

    // Monta a url de requisição
    var request = {
        'option': 'com_ajax',
        'module': 'nobosscalendar',
        'method': 'getEventJson',
        'format': 'raw',
        'lang': lang
    };
    // Monta os dados a serem enviados
    var data = {
        'id_calendar': idCalendar
    };

    // Executa requisicao ajax
    jQuery.ajax({
        url: baseNameUrl+ "?" + jQuery.param(request),
        type: "POST",
        dataType: 'JSON',
        async: false,
        data: data
    }).done(function (result) {
        // Se nao estiver definido, nao faz nada.
        if((result == null) || (result == '')){
        } 
        // Ocorreu um erro
        else if (result.success == 0){
            // Exibe um alerta avisando que teve erro de conexão e não foi possivel obter o plano da extensão
            jQuery.alert({
                title: 'Error',
                content: result.error_database,
                type: 'red',
                buttons: {
                    ok: {
                        keys: ['enter']
                    }
                }
            });
        }
        // Dados obtidos com sucesso
        else{
            if ((result.events !== undefined) && (result.events.length > 0)){
               
               try{
                    // Percorre cada evento para converter em objeto e salvar na variavel
                    nobossCalendarSubform.hiddenValue = jQuery.map(result.events, function (obj) {
                        // Converte o json do evento para um objeto
                        obj = JSON.parse(obj);
                        // Converte o json do campo recurrent_days em um objeto
                        if((obj.recurrent_days !== undefined) && (obj.recurrent_days.length > 0)){
                            obj.recurrent_days = JSON.parse(obj.recurrent_days);
                        }
                        // Converte o json do campo specific_dates em um objeto
                        if((obj.specific_dates !== undefined) && (obj.specific_dates.length > 0)){
                            obj.specific_dates = JSON.parse(obj.specific_dates);
                        }
                        // Converte o json do campo hours em um objeto
                        if((obj.hours !== undefined) && (obj.hours.length > 0)){
                            // Converte ## em aspas (foi alterado antes para nao dar problema no json transitando via js)
                            obj.hours = obj.hours.replace(/"/g, '\\"');
                            //obj.hours = JSON.parse(obj.hours);
                        }
                        // Converte o json do campo recurrent_days_ignore em um objeto
                        if((obj.recurrent_days_ignore !== undefined) && (obj.recurrent_days_ignore.length > 0)){
                            obj.recurrent_days_ignore = JSON.parse(obj.recurrent_days_ignore);
                        }

                        return obj;
                    });
                    
                }

                // Trata eventuais erros
                catch (e) {
                    // Erro de sintaxe (normalmente ocorre por problema de caracter invalido nos dados retornados do curso)
                    if (e instanceof SyntaxError) {
                        jQuery.alert({
                            title: 'Error',
                            content: result.error_json,
                            type: 'red',
                            buttons: {
                                ok: {
                                    keys: ['enter']
                                }
                            }
                        });

                    }
                    // Ocorreu algum outro erro de JS
                    else {
                        jQuery.alert({
                            title: 'Error',
                            content: result.error_js + e.message,
                            type: 'red',
                            buttons: {
                                ok: {
                                    keys: ['enter']
                                }
                            }
                        });
                    }
                }

               // console.log(nobossCalendarSubform.hiddenValue[0]);
            }
        }
    });

    // TODO: DEPRECATED: codigo abaixo serve para manter compatibilidade com usuarios que nao editaram o modulo desde o lancamento da versao com tabela de banco propria. Remover o codigo apos 08/2020
    // verifica se o objeto foi criado com sucesso (quando o input hidden ta vazio o objeto eh criado vazio)
    if (!nobossCalendarSubform.hiddenValue || nobossCalendarSubform.hiddenValue == '') {
        // Obtem valor do input hidden que armazena um json contendo todos os eventos (modelo obtendo dados da coluna 'params' do proprio modulo)
        nobossCalendarSubform.hiddenValue = JSON.parse(jQuery('[data-id="calendar-input-hidden"][data-theme=' + jQuery('[data-id="theme-modal-input"]').val() + ']').val());        
    }
    // Se nao existir eventos cadastrados declara objeto para nao dar erro
    if (!nobossCalendarSubform.hiddenValue) {
        // declara como um novo objeto
        nobossCalendarSubform.hiddenValue = {};
    } else {
        // se ainda nao haver itens no array
        if (nobossCalendarSubform.hiddenValue.length == 0) {
            // inicia a variavel de controle zerada
            nobossCalendarSubform.controlCounter = 0;
        } else {
            // atualiza a variavel de controle
            nobossCalendarSubform.controlCounter = Object.keys(nobossCalendarSubform.hiddenValue)[Object.keys(nobossCalendarSubform.hiddenValue).length - 1];
        }
    }

    // Evento para quando usuario clicar em botao de remover um item do subform
    jQuery(document).on('click', '[data-bt="remove-item"]', function () {
        var id_event = jQuery(this).closest('.subform-repeatable-group').find('input[name$="\\[id_event\\]"]').val();
        
        // Id de evento definido: armazena em array para saber que deve ser removido do banco
        if ((id_event !== undefined) && (id_event != '')){
            nobossCalendarSubform.eventsToRemove.push(id_event);
        }
    });

};

/**
 * Funcao executada quando um filtro eh aplicado
 * 
 * Pega o ano e mes selecionado e exibe os eventos que se aplicam ao filtro
 */
nobossCalendarSubform.applyFilter = function () {
    // Verifica se os campos obrigatorios foram preenchidos
    if (!document.formvalidator.isValid(document.adminForm)) {
        return false; 
    }
    // Esconde a area de exibicao de items do subform enquanto carrega os dados
    jQuery('.subform-repeatable').hide();
    // botao clicado
    var clicked = jQuery(this);
    // secao de filtro desse botao especifico
    var filterSection = clicked.closest('[data-id="items-filter"]');
    // tema relacionado com esse subform
    var relatedTheme = filterSection.data('theme');
    // elemento do subform desse tema
    var subform = filterSection.siblings('.row-fluid');
    // botao de adicionar item
    var addButton = subform.find('.btn-toolbar').find('.btn-group').find('a.group-add').first();
    // botao de limpar os itens
    var resetButton = subform.find('[data-id="noboss-subform-reset"]');
    // botoes de abrir e fechar o collapse
    var collapseButtons = resetButton.closest('.row-fluid').find('[data-id="noboss-collapse-button"]');
    // verifica se existe itens sendo exibidos
    if (subform.find('.subform-repeatable-group[data-base-name="' + relatedTheme + '"]').length) {
        // adiciona eles de volta ao array de controle
        nobossCalendarSubform.addItemsToArray(subform);
    }
    // Selecionada opcao 'todos os anos': esconde o filtro de mes
    if (filterSection.find('[data-id="year-filter"]').val() == "all"){
        filterSection.find('[data-id="month-filter"]').val('all').parent().hide();
    }
    // Selecionada opcao de um ano válido: exibe o filtro de mes
    else{
        filterSection.find('[data-id="month-filter"]').parent().show();
    }
    // se um mes nao foi selecionado sai da funcao
    if (filterSection.find('[data-id="month-filter"]').val() == "") {
        // exibe alerta de selecionar mes
        filterSection.find('[data-id="no-month-alert"]').slideDown();
        // esconde alerta de sem eventos encontrados
        filterSection.find('[data-id="no-results-alert"]').slideUp();
        // esconde o botao de limpar dados do subform pois nao ha itens
        resetButton.hide();
        // aproveita requisicao para pegar botoes de expandir e recolher que tambem seguem mesma regra
        collapseButtons.hide();
        return;
    }
    // esconde o aviso de selecionar mes
    filterSection.find('[data-id="no-month-alert"]').slideUp();
    // Adiciona loader durante carregamento dos dados (se ja nao estiver exibido)
    // if (jQuery("div.loader--fullpage").length == 0){
    //     jQuery('body').append('<div class="loader loader--fullpage"></div>');
    //     jQuery('body').append('<div class="loader-fade"></div>');
    // }
    // guarda o ano selecionado
    var year = filterSection.find('[data-id="year-filter"]').val();
    // guarda o mes selecionado
    var month = filterSection.find('[data-id="month-filter"]').val();

    // Selecionado para exibir todos os anos: seta search para pesquisar por todos resultados
    if(year == 'all'){
        var search = ''
    }
    // Selecionado para exibir todos os meses: pesquisa somente por ano
    else if (month == 'all'){
        var search = year + "-";
        // Monta data do primerio dia do ano selecionado
        var startDateFilter = new Date(year + "-01-01 15:59");
    }
    // Pesquisa por ano e mes
    else{
        var search = year + "-" + month;
        // Monta data do primeiro dia do mes pesquisado
        var startDateFilter = new Date(year + "-" + month + "-01 15:59");
    }

    // verifica se existe eventos
    if (nobossCalendarSubform.hiddenValue) {
        // percorre cada evento cadastrado
        jQuery.each(nobossCalendarSubform.hiddenValue, function (i, obj) {
            // pula indexes sem valor
            if (typeof obj === "undefined") {
                return;
            }
            // Data inicial do evento em formato Date
            var startDateEvent = new Date(obj.initial_date + ' 15:59');

            // Data final do evento em formato Date (caso esteja definido)
            if (obj.final_date != ''){
                var endDateEvent = new Date(obj.final_date + ' 15:59');
            }

            // Variavel para controlar se evento sera exibido na tela
            var displayEvent = false;

            // Setado para exibir todos eventos
            if (search === ''){
                displayEvent = true;
            }
            // Evento recorrente e do tipo de exibir datas especificas
            else if ((obj.is_recurrent == 1) && ((obj.recurrence_type == 'specific-dates') || (obj.recurrence_type == 'specific-dates-hours'))){
                // Percorre cada data do evento
                obj.specific_dates.forEach(function (dateCurrent, indice, array) {
                    dateCurrent = new Date(dateCurrent + ' 15:59');

                    // Data corrente tem ano igual ao filtro selecionado
                    if(dateCurrent.getFullYear() == startDateFilter.getFullYear()){
                        // Esta setado para exibir todos os meses do ano: exibe evento
                        if (month == 'all'){
                            displayEvent = true;
                        }
                        // Data corrente tem mes igual ao filtro selecionado
                        else if(dateCurrent.getMonth() == startDateFilter.getMonth()){
                            displayEvent = true;
                        }
                    }
                });
            }
            // Data do filtro fecha com data inicial do evento OU foi selecionado para exibir todos eventos
            else if (obj.initial_date.indexOf(search) == 0) {
                displayEvent = true;
            }
            // Evento recorrente (nao inclui opcao de datas especificas), data final nao esta preenchida e data do filtro eh maior ou igual que data inicial do evento
            else if((obj.is_recurrent==1) && (obj.final_date == '') && (startDateFilter >= startDateEvent)){
                displayEvent = true;
            }
            // Data final definida e data final do evento eh mais ou igual que a data do filtro e data inicial do evento eh menor ou igual que data do filtro
            else if((obj.final_date != '') && (endDateEvent >= startDateFilter) && (startDateEvent <= startDateFilter)){
                displayEvent = true;
            }

            // Exibir evento no subform
            if (displayEvent){
                // adiciona novo item do subform
                addButton.click();
                // guarda o 'novo' item que foi adicionado
                var newItem = subform.find('[data-new="true"][data-base-name="' + relatedTheme + '"]').last();

                // Insere botao de duplicacao no item do subform
                /* TODO: no futuro migrar esse botao para o layout do nobosssubform vinculado a library
                            - la deveremos ter um parametro que soh exibe botao se estiver definido no xml, como fazemos para os botoes de criar e remover
                            - ajustar tb a classe css colocada que esta com 'btn-success' e um style fixo para right. Devemos ter uma classe css propria para esse botao
                */
                newItem.find(".btn-toolbar .btn-group").prepend('<a data-bt="duplicate-item" class="btn btn-mini button btn-success" style="right: 92px !important;"><span class="icon-copy" aria-hidden="true"></span></a>');

                // insere os valores desse objeto nos campos do item de subform recem criado
                nobossCalendarSubform.objectToSubform(obj, newItem);
                // remove esse item do array pois agora ele esta sendo exibido
                delete nobossCalendarSubform.hiddenValue[i];
            }
        });
    }

    setTimeout(function () {
        // verifica se nao ha itens sendo exibidos
        if (!subform.find('.subform-repeatable-group[data-base-name="' + relatedTheme + '"]').length) {
            // exibe aviso de que nao ha eventos para exibir
            filterSection.find('[data-id="no-results-alert"]').slideDown();
            // esconde o botao de limpar dados do subform pois nao ha itens
            resetButton.hide();
             // aproveita requisicao para pegar botoes de expandir e recolher que tambem seguem mesma regra
            collapseButtons.hide();
        }
        // Tem itens sendo exibidos
        else {
            // caso tenha itens colapsa todos eles
            if (typeof nobosssubform !== "undefined") {
                nobosssubform.toggleCollapseAll('shrink', subform);
            }
            // e esconde a mensagem de sem resultados encontrados
            filterSection.find('[data-id="no-results-alert"]').slideUp();

            // Tema eh de cards
            if (relatedTheme == 'model2'){
                // Remove do subform o campo que permite duplicar eventos por data
                subform.find('[id$="one_event_schedule"]').parent().parent().remove();
            }
        }
        // Exibe itens do subform (deixamos escondido antes de terminar de carregar para nao ficar 'piscando' a abertura e fechamento do collapse)
        jQuery('.subform-repeatable').show();
        // remove o loader
        jQuery('body').find('.loader.loader--fullpage').remove();
        jQuery('body').find('.loader-fade').remove();
    }, 550);
};
 
/**
 * Adicionar os eventos que estao sendo exibidos ao array de controle
 */
nobossCalendarSubform.addItemsToArray = function (subform) {
    // Obtem o modelo de tema
    var theme = jQuery('[data-id="theme-modal-input"]').val();

    // guarda os itens exibidos nesse subform
    var subformItems = subform.find('.subform-repeatable-group[data-base-name="'+theme+'"]');
    // percorre os itens exibidos
    subformItems.each(function () {
        // cria objeto a partir das informacoes preenchidas nesse item de subform
        var obj = nobossCalendarSubform.subformToObject(jQuery(this));

        // adiciona ao array de controle que contem todos os eventos, na ultima posicao
        nobossCalendarSubform.controlCounter++;
        nobossCalendarSubform.hiddenValue[nobossCalendarSubform.controlCounter] = obj;

        try{
            // Mata editor para evitar dar erro de js qnd remover ele da pagina
            if ((typeof tinymce.get != "undefined") && (jQuery(this).find('.js-editor-tinymce textarea').length > 0)) {
                tinymce.get(jQuery(this).find('.js-editor-tinymce textarea').attr('id')).remove();
            }
        }
        // Trata eventuais erros
        catch (e) {
            // Exibe erro no console
            console.log("An error occurred in the file 'nobosssubformcalendar.min.js' that does not prevent the extension from functioning normally. Error detail: " + e);
        }

        // Remove campo da pagina
        jQuery(this).remove();
    });
    
};

/**
 * Adiciona dados em um item de subform ja criado
 */
nobossCalendarSubform.objectToSubform = function (obj, subformItem) {
    
    // Evento eh recorrente (campo radio sim/nao)
    var isRecurrent = subformItem.find('input[name$="\\[is_recurrent\\]"][value="' + obj.is_recurrent + '"]');
    isRecurrent.siblings('label[for="' + isRecurrent.attr('id') + '"]').click();

    if ((typeof obj.recurrence_type == "undefined") || (obj.recurrence_type == '')) {
        obj.recurrence_type = 0;
    }
    // Tipo de recorrencia
    subformItem.find('select[name$="\\[recurrence_type\\]"]').first().val(obj.recurrence_type);
    subformItem.find('select[name$="\\[recurrence_type\\]"]').trigger('liszt:updated').trigger('change');
  
    // Dias da semana
    if((obj.recurrent_days !== undefined) && (obj.recurrent_days !== '')){
        // Marca todos inputs como nao selecionado para entao selecionar os que devem
        subformItem.find('input[name$="\\[recurrent_days][]"]').attr('checked', false);

        // Pecorre inputs e preenche corretamente no subform
        Object.keys(obj.recurrent_days).forEach(function(key){
            if (obj.recurrent_days[key] === 1){
                // Seleciona o checkbox            
                subformItem.find('input[name$="\\[recurrent_days][]"][data-recurrent-day="'+key+'"]').attr('checked', true);
            }
        });
    }

    // Horarios do evento: prepara dados em json para ser adicionado posteriormente nos subforms
    if((obj.hours !== undefined) && (obj.hours !== '')){
        // Retira '\' antes das aspas duplas
        obj.hours = obj.hours.replace(/\\"/g, '"');
        //Converte de json para objeto para poder percorrer
        obj.hours = JSON.parse(obj.hours);
    }

    // Recorrencia por datas especificas
    if (obj.recurrence_type == 'specific-dates'){
        // Datas especificas da recorrencia
        if((obj.specific_dates !== undefined) && (obj.specific_dates !== '')){
            // Pecorre opcoes e preenche corretamente no subform
            jQuery.each(obj.specific_dates, function(index, value){
                // Adiciona valor da data corrente ao input
                subformItem.find('select[name$="\\[specific_dates][]"]+div.chzn-container.chzn-container-multi input').focus().val(value);
                // Criar evento keyup
                var daysSpecificDates = jQuery.Event('keyup');
                // Adiciona code 13 (tecla enter) ao evento
                daysSpecificDates.which = 13;
                // Realiza trigger no evento keyup para valor da data adicionado ao input para que seja adicionado visivelmente ao campo
                subformItem.find('select[name$="\\[specific_dates][]"]+div.chzn-container.chzn-container-multi input').trigger(daysSpecificDates);
            });
        }  
    }
    
    // Recorrencia para data e horarios especificos: preenche subform especifico de datas e horarios
    if (obj.recurrence_type == 'specific-dates-hours'){
        // Datas estao definidas (utilizamos o campo de datas especificas para salvar e aqui colocamos no subform correto)
        if((obj.specific_dates !== undefined) && (obj.specific_dates !== '')){
            // Pecorre opcoes e preenche corretamente no subform
            jQuery.each(obj.specific_dates, function(index, value){
                // Somente a partir do segundo item devemos dar trigger para exibir nova linha no subform (primeira linha ja vem exibida)
                if(index > 0){
                    // Adiciona nova linha no subform de horas
                    subformItem.find('input[name$="\\[specific-dates-hours\\]"]').parent().find('a.group-add').first().click();
                }

                // Adiciona a data no campo do ultimo subform exibido
                subformItem.find('[data-base-name="specific-dates-hours"]').last().find('input[name$="\\[date\\]"]').val(value).attr('data-alt-value', value).attr('data-local-value', value);

                // Adiciona hora inicial no campo do ultimo subform exibido
                if (obj.hours[index].initial !== undefined){
                    subformItem.find('[data-base-name="specific-dates-hours"]').last().find('input[name$="\\[initial_time\\]"]').val(obj.hours[index].initial);
                }

                // Adiciona hora final no campo do ultimo subform exibido
                if (obj.hours[index].final !== undefined){
                    subformItem.find('[data-base-name="specific-dates-hours"]').last().find('input[name$="\\[final_time\\]"]').val(obj.hours[index].final);
                }
            });
        }
    }
    // Demais tipos de eventos
    else{
        // Adiciona nova linha no subform de horas para ficar aparecendo para preenchimento
        subformItem.find('input[name$="\\[hours\\]"]').parent().find('a.group-add').first().click();
        
        // Horarios do evento: insere em subform normal
        if((obj.hours !== undefined) && (obj.hours !== '')){
            // Pecorre opcoes e preenche corretamente no subform
            jQuery.each(obj.hours, function(index, value){
                // Somente a partir do segundo item devemos dar trigger para exibir nova linha no subform de horas (primeira linha ja vem exibida)
                if(index > 0){
                    // Adiciona nova linha no subform de horas
                    subformItem.find('input[name$="\\[hours\\]"]').parent().find('a.group-add').first().click();
                }

                // Adiciona hora inicial no campo do ultimo subform exibido
                subformItem.find('[data-base-name="hours"]').last().find('input[name$="\\[initial_time\\]"]').val(value.initial);

                // Adiciona hora final no campo do ultimo subform exibido
                subformItem.find('[data-base-name="hours"]').last().find('input[name$="\\[final_time\\]"]').val(value.final);
            });
        }

        // Campo de exibir um evento para cada horario preenchido
        var oneEventSchedule = subformItem.find('input[name$="\\[one_event_schedule\\]"][value="' + obj.one_event_schedule + '"]');
        oneEventSchedule.siblings('label[for="' + oneEventSchedule.attr('id') + '"]').click();
        
    }


    // Dias a ignorar na recorrencia
    if((obj.recurrent_days_ignore !== undefined) && (obj.recurrent_days_ignore !== '')){
        // Pecorre opcoes e preenche corretamente no subform
        jQuery.each(obj.recurrent_days_ignore, function(index, value){
            // Adiciona valor da data corrente ao input
            subformItem.find('select[name$="\\[recurrent_days_ignore][]"]+div.chzn-container.chzn-container-multi input').focus().val(value);
            // Criar evento keyup
            var daysIgnoreEventKeyUp = jQuery.Event('keyup');
            // Adiciona code 13 (tecla enter) ao evento
            daysIgnoreEventKeyUp.which = 13;
            // Realiza trigger no evento keyup para valor da data adicionado ao input para que seja adicionado visivelmente ao campo
            subformItem.find('select[name$="\\[recurrent_days_ignore][]"]+div.chzn-container.chzn-container-multi input').trigger(daysIgnoreEventKeyUp);
        });
    }
    
    // Data inicial
    subformItem.find('input[name$="\\[initial_date\\]"]').first().val(obj.initial_date).attr('data-alt-value', obj.initial_date).attr('data-local-value', obj.initial_date);

    // Data final
    subformItem.find('input[name$="\\[final_date\\]"]').first().val(obj.final_date).attr('data-alt-value', obj.final_date).attr('data-local-value', obj.final_date);

    // Titulo
    // Altera '##' para aspas simples (eh convertido pra '##' na hora de salvar para ficar compatível)
    obj.event_title    = obj.event_title.replace("##", "'");
    subformItem.find('textarea[name$="\\[event_title\\]"]').first().val(obj.event_title);

    // Texto de apoio
    if (typeof obj.event_subtitle != "undefined") {
        obj.event_subtitle = obj.event_subtitle.replace("##", "'");
        subformItem.find('textarea[name$="\\[event_subtitle\\]"]').first().val(obj.event_subtitle);
    }

    // Local
    if (typeof obj.event_place != "undefined") {
        obj.event_place    = obj.event_place.replace("##", "'");
        subformItem.find('textarea[name$="\\[event_place\\]"]').first().val(obj.event_place);
    }  
    
    // Categoria
    subformItem.find('select[name$="\\[event_category\\]"]').first().val(obj.event_category);
    subformItem.find('select[name$="\\[event_category\\]"]').trigger('liszt:updated').trigger('change');

    // Cor de fundo manual
    if (typeof obj.event_manual_color != "undefined") {
        subformItem.find('input[name$="\\[event_manual_color\\]"]').first().minicolors('value', obj.event_manual_color);
    }
    
    // Sobreescrever cor dos textos (radio sim/nao)
    var manualColor = subformItem.find('input[name$="\\[show_manual_color\\]"][value="' + obj.show_manual_color + '"]');
    manualColor.siblings('label[for="' + manualColor.attr('id') + '"]').click();
    
    // Sobreescrita da cor dos textos
    if (typeof obj.event_text_color != "undefined") {
        subformItem.find('input[name$="\\[event_text_color\\]"]').first().val(obj.event_text_color);
    }

    // Opcao de link (select)
    subformItem.find('select[name$="\\[link_option\\]"]').first().val(obj.link_option);
    subformItem.find('select[name$="\\[link_option\\]"]').trigger('liszt:updated').trigger('change');

    // Opcoes de modal do conteudo (select)
    if (typeof obj.modal_option != "undefined") {
        subformItem.find('select[name$="\\[modal_option\\]"]').first().val(obj.modal_option);
        subformItem.find('select[name$="\\[modal_option\\]"]').trigger('liszt:updated').trigger('change');
    }
    
    // Modal de conteudo com editor html
    if (typeof obj.modal_content != "undefined") {
        obj.modal_content  = obj.modal_content.replace("##", "'");   
        // Adiciona conteudo no textarea e no iframe para o campo do tipo editor chamado 'modal_content'
        //subformItem.find('textarea[name$="\\[modal_content\\]"]').val(decodeURIComponent(obj.modal_content));
        subformItem.find('textarea[name$="\\[modal_content\\]"]').val((obj.modal_content)).parent().find("iframe").contents().find('body').html(obj.modal_content);;
    }

    // Modal de conteudo com artigo
    if (typeof obj.modal_article != "undefined") {
        subformItem.find('input[name$="\\[modal_article\\]"]').first().val(obj.modal_article);
    }

    // Modal de conteudo com modulo
    if (typeof obj.modal_module != "undefined") {
        subformItem.find('select[name$="\\[modal_module\\]"]').first().val(obj.modal_module);
        subformItem.find('select[name$="\\[modal_module\\]"]').trigger('liszt:updated').trigger('change');
    }

    // Url externa
    if (typeof obj.link_external != "undefined") {
        subformItem.find('input[name$="\\[link_external\\]"]').first().val(obj.link_external);
    }

    // Link interno
    if (typeof obj.link_internal != "undefined") {
        subformItem.find('select[name$="\\[link_internal\\]"]').first().val(obj.link_internal);
        subformItem.find('select[name$="\\[link_internal\\]"]').trigger('liszt:updated').trigger('change');
    }

    // Title para link
    if (typeof obj.link_title != "undefined") {
        subformItem.find('textarea[name$="\\[link_title\\]"]').first().val(obj.link_title);
    }
       
    // Abrir link em nova guia (radio sim/nao)
    if (typeof obj.link_target != "undefined") {
        var linkTarget = subformItem.find('input[name$="\\[link_target\\]"][value="' + obj.link_target + '"]');
        linkTarget.siblings('label[for="' + linkTarget.attr('id') + '"]').click();
    }

    // Publicado (select)
    subformItem.find('select[name$="\\[published\\]"]').first().val(obj.published);
    subformItem.find('select[name$="\\[published\\]"]').trigger('liszt:updated').trigger('change');

    // ID do evento
    if (typeof obj.id_event != "undefined") {
        subformItem.find('input[name$="\\[id_event\\]"]').first().val(obj.id_event);
    }
};

/**
 * Prepara objeto para salvar dados de um item do subform no array de controle
 */
nobossCalendarSubform.subformToObject = function (element) {
    // evento eh recorrente (campo radio sim/nao)
    var isRecurrentSection = element.find('fieldset[id$="is_recurrent"]');
    var isRecurrentId = isRecurrentSection.find('label[class*="active"]').first().attr('for');
    var isRecurrent = isRecurrentSection.find('input#' + isRecurrentId).val();

    // Campo de tipo de recorrencia
    var recurrenceType = element.find('select[name$="\\[recurrence_type\\]"]').first().val();

    // Objeto com itens do dia da semana
    var recurrentDays = {};
    // Percorre cada dia da semana para ver quais estao marcados
    element.find('input[name$="\\[recurrent_days][]"]').each(function() {
        // Item selecionado: adiciona no array com valor 1
        if ($(this).is(':checked')) {
            recurrentDays[$(this).attr('data-recurrent-day')] = 1;
        }
        // Item nao selecionado: adiciona no array com valor 0
        else{
            recurrentDays[$(this).attr('data-recurrent-day')] = 0;
        }
    });  

    // Array com datas especificas da recorrencia
    var specificDates = [];

    // Objeto que armazenara os horarios
    var hours = [];

    // Evento do tipo recorrente por data especifica (sem horas)
    if(recurrenceType == 'specific-dates'){
        // Percorre os options de datas especificas para adicionar em array
        element.find('select[name$="\\[specific_dates][]"] option:selected').each(function() {
            specificDates.push($(this).val())
        });
    }

    // Evento recorrente de dadas especificas com horas
    if(recurrenceType == 'specific-dates-hours'){
    
        // Percorre cada linha do subform de datas especificas com horas
        element.find('[data-base-name="specific-dates-hours"]').each(function() {
            // Hora inicial
            var initialTime = jQuery(this).find('input[name$="\\[initial_time\\]"]').val();
            
            // Hora inicial esta em branco: pula item sem armazenar
            if (initialTime == ''){
                return;
            }
            
            // Armazena horarios em objeto
            var hour = {};
            hour.initial = initialTime;
            hour.final = jQuery(this).find('input[name$="\\[final_time\\]"]').val();
            hours.push(hour);

            // Adiciona data no array de datas especificas
            specificDates.push(jQuery(this).find('input[name$="\\[date\\]"]').val())
        });
    }
    // Demais tipos de eventos (possuem campo de horas normais)
    else{
        // Percorre cada linha do subform de horas
        element.find('[data-base-name="hours"]').each(function() {
            // Hora inicial
            var initialTime = jQuery(this).find('input[name$="\\[initial_time\\]"]').val();
            
            // Hora inicial esta em branco: pula item sem armazenar
            if (initialTime == ''){
                return;
            }
            
            // Armazena horarios em objeto
            var hour = {};
            hour.initial = initialTime;
            hour.final = jQuery(this).find('input[name$="\\[final_time\\]"]').val();
            hours.push(hour);
        });

        // Campo que define se deve ser exibido um evento por horario
        var oneEventSchedule = element.find('fieldset[id$="one_event_schedule"]');
        oneEventSchedule = oneEventSchedule.find('input#' + oneEventSchedule.find('label[class*="active"]').first().attr('for')).val();
    }

    // Converte array de datas especificas para objeto
    specificDates = Object.values(specificDates);

    // Converte os horarios para um json
    hours = JSON.stringify(hours);

    // Array com dias a ignorar na recorrencia
    var recurrentDaysIgnore = [];
    // Percorre os options informados para adicionar em array
    element.find('select[name$="\\[recurrent_days_ignore][]"] option:selected').each(function() {
        recurrentDaysIgnore.push($(this).val())
    });
    // Converte para objeto
    recurrentDaysIgnore = Object.values(recurrentDaysIgnore);

    // Campo para selecionar tipo de conteudo da modal
    var modalOption = element.find('select[name$="\\[modal_option\\]"]').first().val();
    // Campo de modal de artigo
    var modalArticle = element.find('input[name$="\\[modal_article\\]"]').first().val();
    // Campo de modal de modulo
    var modalModule = element.find('select[name$="\\[modal_module\\]"]').first().val();
    // data inicial
    var initialDate = element.find('input[name$="\\[initial_date\\]"]').first().val();
    // data final
    var finalDate = element.find('input[name$="\\[final_date\\]"]').first().val();
    // titulo
    var title = element.find('textarea[name$="\\[event_title\\]"]').first().val();
    // texto de apoio
    var subtitle = element.find('textarea[name$="\\[event_subtitle\\]"]').first().val();
    // categoria
    var category = element.find('select[name$="\\[event_category\\]"]').first().val();
    // cor de fundo manual
    var eventColor = element.find('input[name$="\\[event_manual_color\\]"]').first().minicolors('value');
    // local
    var place = element.find('textarea[name$="\\[event_place\\]"]').first().val();
    // sobreescrever cor dos textos
    var textColorSection = element.find('fieldset[id$="show_manual_color"]');
    var manualTextColor = textColorSection.find('input#' + textColorSection.find('label[class*="active"]').first().attr('for')).val();
    // cor dos textos manual
    var textColor = element.find('input[name$="\\[event_text_color\\]"]').first().val();

    // opcao de link
    var linkOption = element.find('select[name$="\\[link_option\\]"]').first().val();
    // url externa
    var externalUrl = element.find('input[name$="\\[link_external\\]"]').first().val();
    // link interno
    var internalLink = element.find('select[name$="\\[link_internal\\]"]').first().val();
    // title html
    var linkTitle = element.find('textarea[name$="\\[link_title\\]"]').first().val();
    // id evento
    var idEvent = element.find('input[name$="\\[id_event\\]"]').first().val();

    // conteudo modal
    var modalContentTextArea = element.find('textarea[name$="\\[modal_content\\]"]');
    var modalContentHtml = modalContentTextArea.parent().find("iframe").contents().find('body').html();
    // Encoda para nao dar problema ao salvar
    //encodeURIComponent(modalContentHtml);
    
    // abrir em nova guia
    var targetLinkSection = element.find('fieldset[id$="link_target"]');
    var targetLinkId = targetLinkSection.find('label[class*="active"]').first().attr('for');
    var isTargetLink = targetLinkSection.find('input#' + targetLinkId).val();
    // estado
    var published = element.find('select[name$="\\[published\\]"]').first().val();

    // monta objeto com os valores setados no subform
    var obj = {};

    // OBS: foram colocadas verificacoes abaixo para armazenar apenas os campos que realmente sao necessarios (ex: se usuario nao habilitou evento recorrente, nao ira salvar campos sobre evento recorrente). Isso eh para ocupar menos espaco nos dados salvos

    obj.is_recurrent = isRecurrent;

    // Evento recorrente
    if (obj.is_recurrent == 1){
        obj.recurrence_type = recurrenceType;
        // Recorrencia por datas especificas
        if((obj.recurrence_type == 'specific-dates') || (obj.recurrence_type == 'specific-dates-hours')){
            obj.specific_dates = specificDates;
        }
        // Recorrencia por dia da semana
        else if (obj.recurrence_type == 'week-days'){
            obj.recurrent_days = recurrentDays;
        }
    }

    // Json com array de objeto dos horarios
    obj.hours = hours.replace(/"/g, '\\"');

    obj.one_event_schedule = oneEventSchedule;

    obj.initial_date = initialDate;
    obj.final_date = finalDate;

    // Datas a ignorar foram preenchidas
    if (recurrentDaysIgnore != ''){
        obj.recurrent_days_ignore = recurrentDaysIgnore;
    }

    obj.link_option = linkOption;
    
    // Evento possui modal de conteudo
    if (obj.link_option == 'modal'){
        obj.modal_option = modalOption;
        // Modal de conteudo do tipo editor html
        if ((obj.modal_option == 'editor') && (modalContentHtml != null) && (modalContentHtml != '')){
            obj.modal_content = modalContentHtml.replace(/'/g, "##");
            obj.modal_content = modalContentHtml.replace(/"/g, "##");
        }
        // Modal de conteudo do tipo artigo
        else if (obj.modal_option == 'article'){
            obj.modal_article = modalArticle;
        }
        // Modal de conteudo do tipo modulo
        else if (obj.modal_option == 'module'){
            obj.modal_module = modalModule;
        }
    }
    // Evento possui link para pagina interna
    else if (obj.link_option == 'internal'){
        obj.link_internal = internalLink;
        obj.link_title = linkTitle;
        obj.link_target = isTargetLink;
    }
    // Evento possui link para pagina interna
    else if (obj.link_option == 'external'){
        obj.link_external = externalUrl;
        obj.link_title = linkTitle;
        obj.link_target = isTargetLink;
    }
    
    obj.event_title = title.replace(/'/g, "##");
    obj.event_title = title.replace(/"/g, "##");

    // Texto de apoio do evento definido
    if (subtitle != ''){
        obj.event_subtitle = subtitle.replace(/'/g, "##");
        obj.event_subtitle = subtitle.replace(/"/g, "##");
    }

    // Local do evento definido
    if (place != ''){
        obj.event_place = place.replace(/'/g, "##");
        obj.event_place = place.replace(/"/g, "##");
    }

    obj.event_category = category;

    // Evento sem categoria: define a cor manualmente
    if (obj.event_category == 'none' || obj.event_category == ''){
        obj.event_manual_color = eventColor;
    }

    obj.show_manual_color = manualTextColor;

    // Sobreescrita da cor dos textos
    if (obj.show_manual_color == 1){
        obj.event_text_color = textColor;
    }
    
    obj.published = published;

    // Data de fim de publicacao foi definido
    if (idEvent != ''){
        obj.id_event = idEvent;
    }

    // retorna objeto completo
    return obj;
};

/**
 *  Atualiza o titulo do collapse
 * 
 *  OBS:A funcao esta originalmente criada no arquivo 'nobosssubform.js', mas aqui esta sobreescrevendo ele
 */
nobosssubform.updateCollapseTitle = function(parentGroup){
    // pega o titulo do evento
    var collapseValueTitle = jQuery(parentGroup).find('textarea[name$="\\[event_title\\]"]').val();
    
    var returnCollapse = '';

    if(collapseValueTitle !== undefined){
        //pega o valor default para quando esta vazio
        if(collapseValueTitle.trim().length === 0){
            returnCollapse = jQuery('[data-collapse-default-value]').data('collapse-default-value');
        }else{
            // Define titulo do evento
            returnCollapse = collapseValueTitle+' | ';
            
            // Obtem informacao se eh evento recorrente
            var isRecurrence = jQuery(parentGroup).find('input[name$="\\[is_recurrent\\]"]').prop('checked');

            // Evento recorrente: coloca no titulo
            if(isRecurrence){
                // Adiciona informacao que eh evento recorrente no label do subform
                returnCollapse += Joomla.JText._("MOD_NOBOSSCALENDAR_SUBFORM_COLLAPSE_TITLE_RECURRENT_INFO");
                
                // Obtem tipo de recorrencia que eh (no caso de evento recorrente)
                var recurrenceType = jQuery(parentGroup).find('select[name$="\\[recurrence_type\\]"]').val();

                // Adiciona o tipo de recorrencia
                switch (recurrenceType) {
                    case 'week-days':
                        returnCollapse += ' ('+Joomla.JText._("MOD_NOBOSSCALENDAR_EVENT_RECURRENCE_TYPE_OPT_WEEK_DAYS").toLowerCase()+')';
                        break;
                
                    case 'specific-dates':
                        returnCollapse += ' ('+Joomla.JText._("MOD_NOBOSSCALENDAR_EVENT_RECURRENCE_TYPE_OPT_SPECIFIC_DATES").toLowerCase()+')';
                        break;

                    case 'specific-dates-hours':
                        returnCollapse += ' ('+Joomla.JText._("MOD_NOBOSSCALENDAR_EVENT_RECURRENCE_TYPE_OPT_SPECIFIC_DATES_HOURS").toLowerCase()+')';
                        break;
                }
            }

            // Evento com data normal
            else{
                // Obtem a data inicial
                var collapseValueInitialDate =  jQuery(parentGroup).find('input[name$="\\[initial_date\\]"]').val();

                // Obtem a data final
                var collapseValueFinalDate =  jQuery(parentGroup).find('input[name$="\\[final_date\\]"]').val();

                // Data inicial definida
                if(collapseValueInitialDate.trim().length != 0){
                    // converte para objeto data (acrescentado a hora 15:59 no final pq sem ela estava reduzindo um dia na conversao da data)
                    var dateInitial = new Date(collapseValueInitialDate + ' 15:59');
                    returnCollapse += dateInitial.toLocaleDateString();
                }

                // Data final definida e diferente de data inicial
                if((collapseValueFinalDate.trim().length != 0) && (collapseValueFinalDate != collapseValueInitialDate)){
                    // converte para objeto data (acrescentado a hora 15:59 no final pq sem ela estava reduzindo um dia na conversao da data)
                    var dateFinal = new Date(collapseValueFinalDate + ' 15:59');
                    returnCollapse += ' - ' + dateFinal.toLocaleDateString();
                }
            }
        }
    }

    //modifica o titulo do collapse adicionando titulo da label e o respectivo valor
    jQuery(parentGroup).find('.noboss-collapse__title').text(returnCollapse);
};

/**
 *  Altera required's dos campos de datas conforme opcao de recorrencia escolhida
 */
nobossCalendarSubform.changeRequiredDateFields = function(element){
    // Evento ativado na troca de 'tipo de recorrencia'
    element.on('change', 'select[name$="\\[recurrence_type\\]"]', function () {
       // Datas especificas
        if (jQuery(this).val() == 'specific-dates'){
            // Remove required do campo de data inicial (nao eh usado o campo nestes casos)
            element.find('input[name$="\\[initial_date\\]"]').removeAttr("required").removeClass('required');
            // Adciona required no campo de datas a especificar
            element.find('select[name$="\\[specific_dates][]"]').attr("required", "true").addClass('required');
            // Remove registros do subform de datas e horas
            element.find('[data-base-name="specific-dates-hours"]').remove();
        }
        // Datas e horas especificas
        else if (jQuery(this).val() == 'specific-dates-hours'){
            // Remove required do campo de data inicial (nao eh usado o campo nestes casos)
            element.find('input[name$="\\[initial_date\\]"]').removeAttr("required").removeClass('required');
            // Remove required no campo de datas a especificar
            element.find('select[name$="\\[specific_dates][]"]').removeAttr("required").removeClass('required');
            // Deixa um item do subform sendo exibido para iniciar preenchimento
            element.find('input[name$="\\[specific-dates-hours\\]"]').parent().find('a.group-add').first().click();
        }
        // Demais recorrencias
        else{
            // Garante que o campo de data inicial esteja com required   
            element.find('input[name$="\\[initial_date\\]"]').attr("required", "true").addClass('required');
            // Remove required no campo de datas a especificar
            element.find('select[name$="\\[specific_dates][]"]').removeAttr("required").removeClass('required');
            // Remove registros do subform de datas e horas
            element.find('[data-base-name="specific-dates-hours"]').remove();
        }
    });
    // Executa trigger no campo de 'tipo de recorrencia' para que execute a funcao acima que verifica se deve adicionar ou remover required
    element.find('select[name$="\\[recurrence_type\\]"]').trigger('liszt:updated').trigger('change');
}

/**
 * Funcao que realiza o clone de um evento conforme solicitacao feita pelo usuario
 */
nobossCalendarSubform.cloneEvent = function(btClicked){
    // Pega o campo hidden para saber o tema escolhido
    var theme = jQuery('[data-id="theme-modal-input"]').val();

    // Obtem o subform
    var subform = jQuery('[data-id="items-filter"][data-theme="' + theme + '"]').siblings('.row-fluid[data-subform-collapse-wrapper]').first();

    // Adiciona novo item no subform
    subform.find('.btn-toolbar').find('.btn-group').find('a.group-add').first().click();

    // Novo item adicionado no subform
    var newEventSubform = subform.find('[data-new="true"][data-base-name="' + theme + '"]').last();

    // Cria um objeto com os dados do item do subform passado como parametro (item copiado)
    var objEventCopy = nobossCalendarSubform.subformToObject(btClicked.closest('.subform-repeatable-group'));

    // Sera o id do evento antes de inserir no novo item do subform
    objEventCopy.id_event = 0;

    // insere os valores desse objeto nos campos do item de subform recem criado
    nobossCalendarSubform.objectToSubform(objEventCopy, newEventSubform);
};
