<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Calendar
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined('_JEXEC') or die();

$legends = $dataCalendar['legends'];
$numCategories = count($legends); 
?>

<div class="nb-calendar__inner">
    <div class="nb-calendar__content" style="<?php echo $itemsCustomization->calendar_background_color; ?>">
        <?php // Adiciona template da tabela do calendário. ?>
        <?php require JModuleHelper::getLayoutPath('mod_nobosscalendar', 'common/calendar_body');?>
    </div>

    <div class="nb-events <?php echo isset($isOpen) && $isOpen ? 'is-open' : ''; echo ($itemsCustomization->display_month_events == '2') ? 'nb-events--slide' : ''; ?>" data-minimumwidth="<?php echo $itemsCustomization->bar_list_minimum_width; ?>" data-eventlist="<?php echo $itemsCustomization->display_month_events; ?>" style='<?php echo $itemsCustomization->calendar_events_background_color; ?>'>
        <?php
        // Sem eventos a exibir no mes 
        if(empty($dataCalendar['days'])){ 
            require JModuleHelper::getLayoutPath('mod_nobosscalendar', 'common/no_events');
        }
        // Tem eventos a exibir
        else {
            ?>
            <button class="nb-back-button" style='<?php echo "color: {$itemsCustomization->events_texts_color};" ?>'>
                <?php echo JText::_('MOD_NOBOSSCALENDAR_MODAL_BUTTON_RETURN'); ?>
            </button>
            <?php 

            // Carrega area que lista todos eventos do mes
            require JModuleHelper::getLayoutPath('mod_nobosscalendar', 'common/day_events');
            
            // Legendas para o mobile
            if(($itemsCustomization->show_legends) && ((count($dataCalendar['legends']) > 1) || $dataCalendar['legends'][0]->id != 'none1')){ 
            ?>
                <div class="nb-legends nb-legends--mobile <?php echo $numCategories == 0 ? 'is-empty' : ''; ?>">
                    <?php if($numCategories > 0){ ?>
                        <?php require JModuleHelper::getLayoutPath('mod_nobosscalendar', 'common/legends'); ?>
                    <?php } ?>
                </div>
            <?php 
            }
        } ?>
    </div>

    <?php 
    // Legendas para o desktop
    if(($itemsCustomization->show_legends) && ((count($dataCalendar['legends']) > 1) || $dataCalendar['legends'][0]->id != 'none1')){ 
    ?>
        <div class="nb-legends nb-legends--desktop <?php echo ($numCategories == 1) ? 'is-single-category' : '' ; ?> <?php echo $numCategories == 0 ? 'is-empty' : ''; ?>">
            <?php
            if($numCategories > 0){
                require JModuleHelper::getLayoutPath('mod_nobosscalendar', 'common/legends');
            }
            ?> 
        </div>
    <?php 
    }

    // Requisicao feita via ajax
    if (isset($isAjax)){
        // Renderiza uma tab style com o estilo
        echo "<style>".reset(JFactory::getDocument()->_style)."</style>";
    }
    ?>
</div>

<?php
// Carrega modais de conteudo escondidas
require JModuleHelper::getLayoutPath($extensionName, 'common/modal');
?>
