<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Calendar
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined('_JEXEC') or die();
// Importa os arquivos da library noboss
jimport('noboss.util.loadextensionassets');
// Define prefixo a ser utilizado na insercao de codigos inline para CSS e JS
$prefixCodeJsAndCss = "[module-id={$moduleName}_{$idModule}]";
// Instancia objeto passando o nome da extensao com prefixo (ex: 'mod_nobossbanners')
$assetsObject = new NoBossUtilLoadExtensionAssets($extensionName, $prefixCodeJsAndCss);
?>
<div class="nb-calendar__header">   
    <nav class="nb-header-controls" style="<?php echo $itemsCustomization->month_header_space; ?>">
        <?php
        // Modelo 3 OU modelo 2
        if(($theme == 'model3') || ($theme == 'model2')){ 
            // OBS: Qnd for modelo 2 (cards) e nao houver eventos para esquerda, adiciona classe css que desabilita botao
           ?>
            <a class="nb-calendar-controls nb-left <?php echo (($theme == 'model2') && (isset($returnEventsCards->show_navigation_prev)) && ($returnEventsCards->show_navigation_prev == 0)) ? 'nb-controls-disabled' : ''; ?>" href="#" role="button" data-slide="prev" title="<?php echo JText::_('MOD_NOBOSSCALENDAR_NAVIGATION_PREV'); ?>">
                <span class="nb-arrows fa <?php echo (!empty($itemsCustomization->arrows_icon)) ? $itemsCustomization->arrows_icon . '-left' : '';  ?>" style="<?php echo $itemsCustomization->arrows_style; ?>"></span>    
                <span class="hidden">prev</span>
                
            </a>
        <?php 
        }
        ?>
        <div class="nb-calendar__date" style="<?php echo $itemsCustomization->month_header_style; ?>">
            <?php
            // Modelo nao eh o 2 (cards) OU eh cards e parametro de navegacao por mes nao esta definido (default eh exibir) OU parametro esta setado para exibir mes
            if(($theme != 'model2') || (!isset($itemsCustomization->browsing_month)) || ($itemsCustomization->browsing_month == 1)){
                // Obtem mes que esta sendo navegado
                //echo $date;
                $currentMonth = $date->monthToString($date->month);

                if($theme != 'model1'){
                    $currentMonth .= ', ' . $date->year;
                }
                if(empty($itemsCustomization->month_header_font_family)){
                    $itemsCustomization->month_header_font_family = 'font-family: inherit;';
                }

                if(empty($itemsCustomization->month_header_color)){
                    $itemsCustomization->month_header_color = "inherit";
                }
               
                // Exibe mes que esta sendo navegado
                echo "<{$itemsCustomization->month_header_tag_html} class='month-header-title' >{$currentMonth}</{$itemsCustomization->month_header_tag_html}>";
            }
            ?>
        </div>
        <?php
        // Modelo 3 OU modelo 2
        if(($theme == 'model3') || ($theme == 'model2')){  
            // OBS: Qnd for modelo 2 (cards) e nao houver eventos para direita, adiciona classe css que desabilita botao
            ?>
            <a class="nb-calendar-controls nb-right <?php echo (($theme == 'model2') && (isset($returnEventsCards->show_navigation_next)) && ($returnEventsCards->show_navigation_next == 0)) ? 'nb-controls-disabled' : ''; ?>" href="#" role="button" data-slide="next" title="<?php echo JText::_('MOD_NOBOSSCALENDAR_NAVIGATION_NEXT'); ?>">
                <span class="nb-arrows fa <?php echo (!empty($itemsCustomization->arrows_icon)) ?  $itemsCustomization->arrows_icon . '-right' : '';  ?>" style="<?php echo $itemsCustomization->arrows_style; ?>"></span>    
                <span class="hidden">next</span>
            </a>
            <?php
        } ?>
    </nav>

</div>

<?php 
require JModuleHelper::getLayoutPath($extensionName, 'style/month_header');
?>
