<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Calendar
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined('_JEXEC') or die();
$s = "";

// Setado para exibir navegacao abaixo do calendario: coloca estilo flex que muda posicao para baixo
if ((!empty($itemsCustomization->position_nav)) && ($itemsCustomization->position_nav == 'down')){
    $s .= "
    .{$module->name} .nb-calendar{
        flex-direction: column-reverse;
        display: flex;
    }
    ";
}

// Acesso mobile
$s .= "@media screen and (max-width: 767px){
        .{$module->name}.{$module->name}--{$theme}{
            {$sectionStyleMobile}
        }
        .{$module->name} .nb-calendar__title{
            {$titleStyleMobile}
        }
        .{$module->name} .nb-calendar__subtitle{
            {$subtitleStyleMobile}
        }
        .{$moduleName} .nb-event__title{
            {$itemsCustomization->events_title_style_mobile}
        }
        .{$moduleName} .nb-event__description{
            {$itemsCustomization->events_subtitle_style_mobile}
        }
        .{$moduleName} .nb-event__time{
            {$itemsCustomization->events_schedule_style_mobile}
        }
        .{$moduleName} .nb-event__localization{
            {$itemsCustomization->events_address_style_mobile}
        }
        .{$moduleName} .nb-calendar__event{
            {$itemsCustomization->min_width_mobile}
        }";
$s .= "}";

// Acesso tablet
$s .= "@media only screen and (min-width: 768px) and (max-width: 991px){
    .{$moduleName} .nb-calendar__event{
        {$itemsCustomization->min_width_tablet}
    }";

$s .= "}";

// chama função que adiciona prefixo em todo o estilo que foi concatenado na variável $s 
$assetsObject->addStyleWithPrefix($s); 

?>
