<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Calendar
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */
 
defined('_JEXEC') or die();
?>
<div class="nb-sidebar" data-now='<?php echo $date; ?>' style='<?php echo "color: {$itemsCustomization->sidebar_text_color};"; ?>'>
    <div class="nb-sidebar__header" style="<?php echo $itemsCustomization->year_header_spacing; ?>">   
        <nav class="nb-header-controls">
            <a class="nb-calendar-controls nb-left" href="#" role="button" data-slide="prev" title="Visualizar anterior">
                <span class="nb-arrows fa <?php echo (!empty($itemsCustomization->arrows_icon)) ? $itemsCustomization->arrows_icon . '-left' : '';  ?>" style="<?php echo $itemsCustomization->arrows_style; ?>"></span>    
                <span class="hidden">prev</span>
            </a>
            <div class="nb-calendar__date" style="text-align: center;">
                <?php
                    echo "<{$itemsCustomization->year_header_tag_html} style='{$itemsCustomization->year_header_size}'>{$date->year}</{$itemsCustomization->year_header_tag_html}>";
                ?>
            </div>
            <a class="nb-calendar-controls nb-right" href="#" role="button" data-slide="next" title="Visualizar próximo">
                <span class="nb-arrows fa <?php echo (!empty($itemsCustomization->arrows_icon)) ?  $itemsCustomization->arrows_icon . '-right' : '';  ?>" style="<?php echo $itemsCustomization->arrows_style; ?>"></span>    
                <span class="hidden">next</span>
            </a>
        </nav>
    </div>
    <div class="nb-sidebar__months">
        <?php 
        foreach ($yearMonths as $dateMonth => $events) { 
            $dateMonth = JDate::getInstance($dateMonth);
            $isActive = $today->month == $dateMonth->month && $today->year == $dateMonth->year ? "is-active" : ""; ?>
            <div class="nb-sidebar__month <?php echo $isActive; ?>" data-month="<?php echo $dateMonth->month; ?>" data-month-date="<?php echo $dateMonth; ?>">
                <a href="http://" class="nb-sidebar__link" style="<?php echo $itemsCustomization->sidebar_months_spacing; ?>">
                    <div class="month-header-title" style='<?php echo $itemsCustomization->sidebar_months_size; ?>'><?php $dateMonth = JDate::getInstance($dateMonth);
                    echo $dateMonth->monthToString($dateMonth->month); ?></div>
                    <?php if($events > 0){ ?>
                        <span class="nb-sidebar__events-number" style='<?php echo "color: {$itemsCustomization->sidebar_background_color};"; ?> <?php echo "background-color: {$itemsCustomization->sidebar_text_color};" ?>'><?php echo $events; ?></span>
                    <?php } ?>
                </a>
            </div>
        <?php 
        }
        ?>
    </div>
</div>
