    <?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Calendar
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined('_JEXEC') or die();
?>

<div class="nb-calendar" style="<?php echo ($itemsCustomization->limit_maximum_width == '1') ? $itemsCustomization->calendar_maximum_width : ''; ?>" data-now="<?php echo $date; ?>">
    <?php
    // Carrega cabecalho de meses
    require JModuleHelper::getLayoutPath($extensionName, 'common/month_header');

    // Sem eventos a exibir
    if(empty((array)$eventsSearch) || !$eventsSearch){
        require JModuleHelper::getLayoutPath($extensionName, 'common/no_events');
    }
    // Exibe eventos do mes
    else { ?>
        <div class="nb-calendar__body">
            <?php
            $count = 0;

            require JModuleHelper::getLayoutPath($extensionName, 'style/' . $theme . '_item');

            // Percorre eventos do mes
            foreach ($eventsSearch as $event) {
                // Obtem datas de inicio e fim
                $dateIni = new JDate($event->initial_date);
                $dateFim = new JDate($event->final_date);

                // Evento tem horario a exibir
                if ((!empty($event->hours)) && (count($event->hours) > 0)){
                    // Quebra horario em array para pegar hora e minutos separadamente
                    $time = explode(':', $event->hours[0]->initial);
                    // Obtem timestamp para o horario inicial (utilizado para montar ordenacao dos resultados via css com flex order)
                    $timestampInitialTime = mktime($time[0], $time[1], 0, $date->month, $event->days[0], $date->year);
                }
                // Evento nao possui horario
                else{
                    // Obtem timestamp apenas da data
                    $timestampInitialTime = mktime(0, 0, 0, $date->month, $event->days[0], $date->year);
                }

                ?>
                <div date-current="<?php echo $dateIni; ?>" class="nb-calendar__event <?php echo $event->link_option == 'modal' ? 'nb-calendar__event--has-modal' : ''; ?> <?php echo ($event->link_option === 'external' || $event->link_option === 'internal') ? 'has-link' : ''; ?>" style='order:<?php echo $timestampInitialTime; ?>; <?php echo $itemsCustomization->min_width; ?> <?php echo "background-color: {$event->event_category->category_color};"; ?> <?php echo ($event->show_manual_color) ? "color: {$event->event_text_color};" : "color: {$itemsCustomization->events_texts_color};"; ?>' <?php echo "module-item-id={$moduleName}_{$idModule}_{$date->month}_{$count}"; ?>>
                    <?php
                    // Evento possui link de url: realiza abertura do <a href>
                    if(!empty($event->link) && ($event->link_option === 'external' || $event->link_option === 'internal')){ ?>
                        <a href="<?php echo $event->link; ?>" class="nb-event__link" target="<?php echo $event->link_target; ?>" title="<?php echo $event->link_title; ?>">
                    <?php
                    }
                    ?>

                    <div class="nb-event__content">
                        <?php if($event->event_category->id != "none" && !empty($event->event_category->show_in_legends) && $event->event_category->show_in_legends){ ?>
                            <div class="nb-event-legend" >
                                <span class="legend__tag" style='<?php echo $itemsCustomization->events_title_font_family; ?> <?php echo "color: {$event->event_category->category_color};" ?>'><?php echo $event->event_category->legend; ?></span>
                            </div>
                        <?php } ?>

                        <div class="nb-event__date">
                            <?php // Data inicial ?>
                            <div class="nb-day__start" <?php echo $event->is_recurrent ? 'start-date-id="event-recurrent"' : '';?>>
                                <span class="nb-event__month" style='<?php echo $itemsCustomization->events_title_font_family; ?> text-transform: <?php echo $itemsCustomization->events_title_transform; ?>;'>
                                    <?php echo $dateIni->format('M'); ?>
                                </span>
                                <span class="nb-event__day" style='<?php echo $itemsCustomization->events_title_font_family; ?> text-transform: <?php echo $itemsCustomization->events_title_transform; ?>;'>
                                    <?php
                                        // Evento recorrente: exibe datas que ocorre no mes (exibido por default qnd vem todos eventos do mes listados, mas qnd usuario ve o evento clicando em uma data, exibe apenas o dia clicado via JS)
                                        if ($event->is_recurrent){
                                            echo implode(', ', $event->days);
                                        }
                                        // Evento normal
                                        else{
                                            echo $dateIni->format('d');
                                        }
                                    ?>
                                </span>
                            </div>

                            <?php 
                            // Data final diferente de data inicial e nao eh evento recorrente: exibe tb a data final
                            if (($dateIni != $dateFim) && (!$event->is_recurrent)){
                                ?>
                                <div class="nb-day__end">
                                    <span class="nb-event__month" style='<?php echo $itemsCustomization->events_title_font_family; ?> text-transform: <?php echo $itemsCustomization->events_title_transform; ?>;'>
                                        <?php
                                        if ($event->is_recurrent){
                                            echo $date->format('M');
                                        }
                                        // Evento normal
                                        else{
                                            echo $dateFim->format('M');
                                        }
                                        ?>
                                    </span>
                                    <span class="nb-event__day nb-event__day--last" style='<?php echo $itemsCustomization->events_title_font_family; ?> text-transform: <?php echo $itemsCustomization->events_title_transform; ?>;'>
                                        <?php
                                            echo $dateFim->format('d');
                                        ?>
                                    </span>
                                </div>
                                <?php
                            }
                            ?>
                        </div>
                        <div class="nb-event__infos">
                            <?php
                                if (!empty(rtrim($event->event_title))) {
                                    echo "<{$itemsCustomization->events_title_tag_html} class='nb-event__title' style='padding-top: 10px; {$itemsCustomization->events_title_style}'>{$event->event_title}</{$itemsCustomization->events_title_tag_html}>";
                                }
                            ?>
                            <?php
                                if (!empty(rtrim($event->event_subtitle))) {
                                    echo "<{$itemsCustomization->events_subtitle_tag_html} class='nb-event__description' style='padding: 10px 0px; {$itemsCustomization->events_subtitle_style}'>{$event->event_subtitle}</{$itemsCustomization->events_subtitle_tag_html}>";
                                }
                            ?>
                        </div>
                        <div class="nb-event__especifications">
                            <div style="">
                                <?php if(!empty($event->hours)){ ?>
                                    <span class="nb-event__time" style='<?php echo $itemsCustomization->events_subtitle_font_family; ?> <?php echo $itemsCustomization->events_schedule_style; ?> text-align: <?php echo $itemsCustomization->events_subtitle_alignment; ?>; '>
                                        <?php
                                        // Percorre todos horarios do evento
                                        foreach ($event->hours as $key => $hour) {
                                            // Se nao for o primeiro item, adiciona um separador
                                            if($key > 0){
                                                echo ' | ';
                                            }
                                            // Exibe da hora inicial
                                            echo $hour->initial;
                                            // Exibe hora final (caso seja diferente da inicial)
                                            if(!empty($hour->final) && ($hour->initial != $hour->final)){
                                                echo ' - '.$hour->final;
                                            }
                                        }
                                        ?>
                                    </span>
                                <?php } ?>
                                <?php if(!empty(rtrim($event->event_place))){ ?>
                                    <span class="nb-event__localization" style='<?php echo $itemsCustomization->events_subtitle_font_family; ?> <?php echo $itemsCustomization->events_address_style; ?>'><?php echo $event->event_place; ?></span>
                                <?php } ?>
                            </div>
                        </div>
                    </div>
                    <?php // Fecha link, caso definido ?>
                    <?php if(!empty($event->link) && ($event->link_option === 'external' || $event->link_option === 'internal')){ ?>
                        </a>
                    <?php } ?>
                </div>
                <?php
                // Evento possui modal de conteudo
                if($event->link_option == 'modal' && !empty($event->modal_content)){
                    // Armazena id criado para o evento para saber na modal qual deve ser aberta
                    $event->moduleItemId = "{$moduleName}_{$idModule}_{$date->month}_{$count}";
                    $arrayEventsModal[] = $event;
                }
                $count++;
            }
            ?>
        </div>
        <?php
    }
    ?>
</div>

<?php
// Carrega modais de conteudo
require JModuleHelper::getLayoutPath($extensionName, 'common/modal');
?>
