<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	com_nobossajax
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined('_JEXEC') or die;

error_reporting(0);

// Reference global application object
$app = JFactory::getApplication();

// JInput object
$input = $app->input;

/*
 * Requisicao de modulo com chamada por posicao
 * Ex de chamada: URLSITE/index.php?option=com_nobossajax&module-position=footer
 * 	* Parametros opcionais: 
 * 		* load-css (define se deve carregar arquivos CSS da extensao)
 * 		* load-js (define se deve carregar arquivos JS da extensao)
 */
if ($input->get('module-position')){
	$modules = JModuleHelper::getModules($input->get('module-position'));
	
	// Existem modulos na posicao
	if(is_array($modules)){
		// Carrega todos modulos da posicao
		foreach($modules as $content){
			echo JModuleHelper::renderModule($content);
		}		
    }
    $doc = JFactory::getDocument();
	
	// Verifica de deve carregar CSS (default eh sim)
	if ($input->get('load-css', '1')){
		// pega estilos da tag style que estao em array e transforma em string
		$style = implode($doc->_style);
		// adiciona na pagina
		echo "<style>{$style}</style>";
		// pega o array de estilos que ficao em arquivo css
		$stylesheets = $doc->_styleSheets; 
		// pega as keys dele que sao as urls
		$stylesheetsUrls = array_keys($stylesheets);
		// faz a chamada dos arquivos css na pagina
		foreach($stylesheetsUrls as $url){
			echo "<link href={$url} rel='stylesheet' type='text/css'>";
		}
	}
	
	// Verifica de deve carregar JS (default eh sim)
	if ($input->get('load-js', '1')){
		// pega o array de scripts que devem ficar dentro da tag script e transforma em string
		$script = implode($doc->_script);
		// adiciona na pagina
		echo "<script>{$script}</script>";
		// pega o array  de scripts que ficam num arquivo externo
		$scripts = $doc->_scripts; 
		// pega as keys que sao as urls
		$scriptsUrls = array_keys($scripts);
		// faz a chamada dos arquivos na pagina
		foreach($scriptsUrls as $url){
			echo "<script src={$url}></script>";
		}
	}

	exit;
}
// Requisicao para library
else if ($input->get('library')){
	$library       = $input->get('library');
	$method        = $input->get('method');
	$class		   = $input->get('class');
	$libPath	   = explode(".", $library);
	$fileName	   = end($libPath);
	$libName 	   = reset($libPath);
	
	// Verifica se está setado uma library
	if ($library){
		jimport($library);
		
		if (!isset($class) || empty($class)){
			$class = ucfirst($libName) . ucfirst($fileName);
		}
		
		$method = $input->get('method') ? $input->get('method') : 'get';

		if (method_exists($class, $method)){
			try{
				$results = call_user_func($class . '::' . $method);
			}catch (Exception $e){
				$results = $e;
			}
		}
		// Method does not exist
		else{
			$results = new LogicException(JText::sprintf('COM_AJAX_METHOD_NOT_EXISTS', $method), 404);
		}
	}

}
else{
	// Caso não seja uma requisição para a library, só inclui o com_ajax do joomla
	require_once JPATH_SITE . '/components/com_ajax/ajax.php';
}
