/**
 * Classe com funcoes para bloqueio de campos conforme dados de licenca de um usuario
 */
jQuery(document).ready(function($) {
	blockfields.CONSTRUCTOR();
});
// Variável que armazena funções.
var blockfields = {};

// Metodo construtor
blockfields.CONSTRUCTOR = function() {
    // Verifica a cada 1s se os dados da licenca ja foram carregados
    blockfields.licensedataloaded = setInterval(function() {
        // Dados da licenca carregados
        if(nobosslicense.licenseInfo != undefined){
            // Para execucao do setInterval
            clearInterval(blockfields.licensedataloaded);
            // Executa funcao que faz os bloqueios
            blockfields.blocksLicense('all');
        }
    }, 1000);
};

/**
 * Funcao que bloqueia os campos conforme informacoes definidas na licenca do usuario
 * 
 * OBS: eh possivel bloquear: campos normais, campos dentro de subform, campos dentro de modais, modais inteiras e subforms inteiros
 * 
 * @param   String  type    Define o tipo de bloqueio a considerar na execucao de bloqueio ('all': todas situacoes | 'subform': itens de subforms | 'sunform-complete': bloqueio de subforms inteiros | 'modal': bloqueio de itens de uma modal | 'modal-complete': bloqueio de modais inteiras)
 *
 * @return void
 */
blockfields.blocksLicense = function (type) {    
    // Campos a bloquear definidos
    if((nobosslicense.licenseInfo.data != undefined) && (nobosslicense.licenseInfo.data.fields_block != undefined) && (nobosslicense.licenseInfo.data.fields_block != '')){
        // Percorre cada campo a bloquear
        jQuery.each(nobosslicense.licenseInfo.data.fields_block.split(','), function (i, itemBlock) {
            // Converte o item em um array sendo cada valor que estava dentro de '[]' como uma posicao
            itemBlock = itemBlock.substr(1, (itemBlock.length-2)).split('][');

            var fieldBlock, subformBlock, modalBlock = '';
            var valueDefaultBlock = '-1';

            // Bloqueio de um campo especifico de subform
            if(((type == 'all') || (type == 'subform')) && (itemBlock.length >= 3) && (itemBlock[0] == 'subform')){
                // Armazena alias do subform
                subformBlock = itemBlock[1];
                // Armazena o alias do campo
                fieldBlock = itemBlock[2];
                // Armazena como chegar ateh o input do campo
                fieldBlock = jQuery('[data-base-name] .controls [name*="\\['+subformBlock+'\\]"][name*="\\['+fieldBlock+'\\]"]');

                // Esta definido um valor default para o campo
                if (itemBlock.length == 4){
                    valueDefaultBlock = itemBlock[3];
                }
            }
            // Bloqueio de um subform inteiro
            else if(((type == 'all') || (type == 'subform-complete')) && (itemBlock.length >= 2) && (itemBlock[0] == 'subform-complete')){
                // Armazena alias do subform
                subformBlock = itemBlock[1];

                // QND FOR SUBFORM MULTIPLO: exibe mensagem acima do subform (quando for subform multiplo apenas) e remove subform da pagina
                jQuery('[data-id="noboss-subform-reset"][data-name="'+subformBlock+'"], .subform-repeatable-wrapper [data-base-name="'+subformBlock+'"]:first, .controls [name*="\\['+subformBlock+'\\]"]').closest('.control-group').html('').before("<div class='alert' style='font-size: 13px; margin: 0 0 10px 0; display: inline-block;'><span class='icon-minus-circle'> </span>"+Joomla.JText._('LIB_NOBOSS_BLOCK_FIELD_SUBFORM_HEADER')+"</div>"); 

                // WND FOR SUBFOM UNICO: percorre todos os campos do subform (quando for unico e nao multiplo)
                jQuery('.noboss-subform-single[data-base-name="'+subformBlock+'"] .controls [name]').each(function () {
                    // Campo dentro do subform eh uma modal
                    if (jQuery(this).attr('data-modal-name')){
                        // Adiciona a modal como item a ser bloqueado (qnd abrir a modal o js dela vai ler essa variavael)
                        nobosslicense.licenseInfo.data.fields_block += '[modal-complete]['+jQuery(this).attr('data-modal-name')+']';
                        // Executa funcao que exibe mensagem ao lado do botao da modal
                        blockfields.modalTextBlock(jQuery(this).attr('data-modal-name'));
                    }
                    // Campo normal
                    else{
                        // Executa funcao que bloqueia o campo
                        blockfields.blockField(jQuery(this), valueDefaultBlock);
                    }
                });
            }
            // Bloqueio de um campo especifico de modal
            else if(((type == 'all') || (type == 'modal')) && (itemBlock.length >= 3) && (itemBlock[0] == 'modal')){
                // Armazena alias da modal
                modalBlock = itemBlock[1];
                // Armazena o alias do campo
                fieldBlock = itemBlock[2];
                // Armazena como chegar ateh o input do campo
                fieldBlock = jQuery('.noboss-modal .nb-modal-content .controls [name="'+modalBlock+'\\['+fieldBlock+'\\]"]');
                // Esta definido um valor default para o campo
                if (itemBlock.length == 4){
                    valueDefaultBlock = itemBlock[3];
                }
            }
            // Bloqueio de uma modal inteira
            else if(((type == 'all') || (type == 'modal-complete')) && (itemBlock.length >= 2) && (itemBlock[0] == 'modal-complete')){
                // Armazena alias da modal
                modalBlock = itemBlock[1];
                // Executa funcao que exibe mensagem ao lado do botao da modal
                blockfields.modalTextBlock(modalBlock);
                // OBS: o bloqueio dos campos e mensagem dentro da modal, sao feitos direto no JS da modal
            }
            // Bloqueio de campo espeficico que nao esta em modal e nem subform
            else if(((type == 'all') || (type == 'field')) && (itemBlock.length == 1) || (itemBlock.length == 2)){
                // Armazena o alias do campo
                fieldBlock = itemBlock[0];
                // Armazena como chegar ateh o input do campo
                fieldBlock = jQuery('.controls [name*="\\['+fieldBlock+'\\]"]');

                // Esta definido um valor default para o campo
                if (itemBlock.length == 2){
                    valueDefaultBlock = itemBlock[1];
                }
            }
            else{
                return;
            }

            // Ha campo para bloquear
            if((fieldBlock != '') && (fieldBlock != undefined)){
                // Executa funcao que bloqueia o campo
                blockfields.blockField(fieldBlock, valueDefaultBlock);
            }
            
        });
    }
};

/**
 * Funcao que bloqueia um campo espefifico informado
 * 
 * @param   String  fieldBlock   Identificador para chegar ate o campo
 *
 * @return void
 */
blockfields.blockField = function (fieldBlock, valueDefaultBlock) {  
    
    fieldBlock = fieldBlock.not('[readonly]');

    // Adiciona bloqueio via readonly, remove cursor pointer do campo e desabilita eventos que o campo possa ter
    fieldBlock.prop("readonly", true).css({ 'pointer-events': 'none' }).off();
    
    // Ainda nao existe um elemento com classe 'alert' dentro do 'control-group'
    if (fieldBlock.closest('.control-group').find('.alert.not-include').length == 0){
        // Adicioma mensagem ao lado do campo
        fieldBlock.closest('.controls').css({ 'float': 'left', 'margin-left': '15px' }).after("<div class='alert not-include' style='font-size: 11px; padding: 5px; margin: 0 0 0 10px; display: inline-block;'><span class='icon-minus-circle'> </span>"+Joomla.JText._('LIB_NOBOSS_BLOCK_FIELD_SIDE_FIELD')+"</div>"); 
    }
    
    // Campo editor
    if(fieldBlock.parent().parent().hasClass('nb-editor')){
        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            fieldBlock.val(valueDefaultBlock);
        }
        // Cria uma div por cima do editor para impedir edicao e esconde barra com botoes
        fieldBlock.closest('.editor, .js-editor-tinymce').prepend('<div style="position: absolute; z-index: 9999;width: 100%;height: 100%;"></div>').parent().find('.btn-toolbar, .toggle-editor').hide();
    }

    // Campo de minicolors, clockpicker ou calendar
    else if (fieldBlock.hasClass('minicolors') || fieldBlock.parent().hasClass('clockpicker') || fieldBlock.parent().parent().hasClass('field-calendar')){
        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            fieldBlock.val(valueDefaultBlock);
        }
        // Remove evento JS do botao de selecao de data, retirando tb pointer e adicionando disabled
        fieldBlock.parent().find('span, button').attr("disabled", true).css({ 'pointer-events': 'none' }).off();
    }

    // Campo radio
    else if(fieldBlock.attr('type') == 'radio'){
        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            // Percorre todas opcoes do campo radio
            fieldBlock.closest('.controls').find('.btn-group input').each(function () {
                var input = jQuery(this);
                // Campo corrente tem valor igual ao valor default definido: marca campo como ativo e coloca como checkado
                if (input.val() === valueDefaultBlock) {
                    if (input.val() === '') {
                        input.parent().find('label[for="' + input.attr('id') + '"]').addClass('active btn-primary');
                    } else if (input.val() === '0') {
                        input.parent().find('label[for="' + input.attr('id') + '"]').addClass('active btn-danger');
                    } else {
                        input.parent().find('label[for="' + input.attr('id') + '"]').addClass('active btn-success');
                    }

                    input.prop("checked", true);
                }
                // Campo corrente nao tem o mesmo valor default: seta que fique apenas com classe de botao normal
                else {
                    input.parent().find('label[for="' + input.attr('id') + '"]').attr('class', 'btn');
                    input.prop("checked", false);
                }
            });
        }
        // Desabilita campo e adiciona classe desabilitado no fieldset
        fieldBlock.prop("disabled", true).parent().addClass('disabled').css({ 'pointer-events': 'none' });
    }

    // Campo checkbox
    else if(fieldBlock.attr('type') == 'checkbox'){
        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            // Percorre todas opcoes do campo radio
            fieldBlock.closest('.controls').find('.btn-group input').each(function () {
                var input = jQuery(this);
                // Campo corrente tem valor igual ao valor default definido: coloca como checkado
                if (input.val() === valueDefaultBlock) {
                    input.prop("checked", true);
                }
                // Campo corrente nao tem o mesmo valor default: seta que nao fique marcado
                else {
                    input.prop("checked", false);
                }
            });
        }
        // Desabilita campo e adiciona classe desabilitado no fieldset
        fieldBlock.prop("disabled", true).parent().addClass('disabled').css({ 'pointer-events': 'none' });
    }

    // Campo range
    else if(fieldBlock.attr('type') == 'range'){
        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            fieldBlock.val(valueDefaultBlock);
        }
        // Adiciona bloqueio tb no campo que exibe o valor
        fieldBlock.parent().find('[type="number"]').prop("readonly", true).css({ 'pointer-events': 'none' });
    }
    
    // Campo list (select)
    else if(fieldBlock.is('select')){
        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            // Percorre todas opcoes do campo radio
            fieldBlock.find('option').each(function () {
                var input = jQuery(this);
                // Campo corrente tem valor igual ao valor default definido: coloca como selected
                if (input.val() == valueDefaultBlock) {
                    input.attr('selected', true);
                    // Forca mudar texto exibido para span gerado pelo chosen
                    fieldBlock.parent().find('.chzn-single span').html(input.text());
                }
                // Campo corrente nao tem o mesmo valor default: garante que nao fique com selected
                else {
                    input.attr('selected', false);
                }
            });
            // Seta campo com valor default            
            fieldBlock.val(valueDefaultBlock);
            // Realiza trigger no select
            fieldBlock.trigger('change').chosen();
        }

        // Adiciona classe de bloqueio em div do select fake e remove eventos JS da div
        fieldBlock.parent().find('.chzn-container').addClass('chzn-disabled').off();
        // Select do tipo multiples (nobossmultioptionsinput)
        if(fieldBlock.attr('data-id') == 'multi-options-input'){
            // Adiciona bloqueio em input fake onde usuario digita valores a adicionar
            fieldBlock.parent().find('.chzn-container input').prop("disabled", true).css({ 'pointer-events': 'none' });
        }
    }
    
    // Textarea
    else if(fieldBlock.is('textarea')){
        // Adiciona estilo para exibir corretamente
        fieldBlock.closest('.controls').css({ 'display': 'contents' });

        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            fieldBlock.html(valueDefaultBlock);
        }
    }

    // Text
    else if(fieldBlock.attr('type') == 'text'){
        // Adiciona estilo para exibir corretamente
        fieldBlock.css({ 'width': '100%' });

        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            fieldBlock.html(valueDefaultBlock);
        }
    }

    // Demais campos
    else{
        // Definido um valor default a colocar no campo: seta ele (caso contrario mantem o valor que veio do xml)
        if((valueDefaultBlock != '-1') && (valueDefaultBlock != undefined)){
            fieldBlock.val(valueDefaultBlock);
        }
    }
};


/**
 * Funcao que exibe mensagem ao lado do botao da modal bloqueada por completa
 * 
 * @param   String  fieldBlock   Identificador para chegar ate o campo
 *
 * @return void
 */
blockfields.modalTextBlock = function (modalName) {  
    // Exibe mensagem ao lado do botao da modal
    jQuery('[name$="\\['+modalName+'\\]"][data-id="noboss-modal-input-hidden"][readonly!="readonly"]').prop("readonly", true).css({ 'float': 'left' }).after("<div class='alert' style='font-size: 11px; padding: 5px; margin: 0 0 0 10px; display: inline-block;'><span class='icon-minus-circle'> </span>"+Joomla.JText._('LIB_NOBOSS_BLOCK_FIELD_MODAL_COMPLETE_SIDE_FIELD')+"</div>");
};
