var nobossrange = {};

/** 
 * Função construtora, cahmada quando a pagina termina de carregar
*/
nobossrange.CONSTRUCTOR = function() {
    nobossrange.activateFieldsEvents();

    // Evento de clique no subform: reativa js do campo para subform
    jQuery(document).on('subform-row-add', function (event, element) {
        nobossrange.activateFieldsEvents(element);
    });
};

nobossrange.activateFieldsEvents = function(container){
    container = container === undefined ? container === jQuery('body') : container;

    // Evento para quando usuario move bolinha do range
    jQuery('.nobossrange', container).off().change(nobossrange.changeRange);

    // Evento para quando usuario muda valor direto no input
    jQuery('.nobossrange--input', container).off().change(nobossrange.updateRange);

    // Dá um trigger inicial no range para atualizar os inputs
    jQuery('.nobossrange', container).trigger('input');
};

/**
 * Usuario moveu bolinha do range
 * 
 * @param {Event} event Evento de input no range 
 */
nobossrange.changeRange = function(event) {
    var value = jQuery(this).val();
    // Atualiza valor do input
    jQuery(this).siblings('.nobossrange--input').val(value);
};

/**
 * Atualiza o range conforme valor informado pelo usuario
 * 
 * @param {Event} event Evento de input no range 
 */
nobossrange.updateRange = function(event) {
    var value = jQuery(this).val();
    // Atualiza o 
    jQuery(this).siblings('.nobossrange').val(value);
    
    // Verifica se valor informado nao esta fora dos limites do campo
    nobossrange.validateValue(jQuery(this));
};

/**
 * Verifica se o elemento está dentro do range de min e max
 * @param {jQuery Object} el elemento input que será validado 
 */

nobossrange.validateValue = function(el) {
    var value = parseInt(el.val());

    if ((value != '') && (value != undefined)){
        // Caso seja maior que o min, define o valor como o min
        if (value < parseInt(el.attr('min'))){
            el.val(el.attr('min'));
        }
        // Caso seja maior que o max, define o valor como o max
        else if(value > parseInt(el.attr('max'))){
            el.val(el.attr('max'));
        }
        
        // Dá um trigger para atualizar o range
        jQuery(el).trigger('input');
    }
};

jQuery(document).ready(function () {
    nobossrange.CONSTRUCTOR();
});
