<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Library
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined("JPATH_PLATFORM") or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('textarea');

class JFormFieldNobosscustomcss extends JFormFieldTextarea{

    protected $type = "nobosscustomcss";

    protected function getInput(){
        // seta o placeholder
        $this->hint = JText::_('NOBOSS_EXTENSIONS_CSS_OVERWRITE_PLACEHOLDER');

        $this->class = "nb-custom-editor-css";

        $doc = JFactory::getDocument();
        $doc->addStylesheet(JURI::root()."libraries/noboss/forms/fields/assets/stylesheets/css/nobosscustomcss.min.css");
        $doc->addScript(JURI::root()."libraries/noboss/forms/fields/assets/js/min/nobosscustomcss.min.js");
        
        return parent::getInput();
    }  

}
