<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Library
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined("JPATH_PLATFORM") or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('textarea');

class JFormFieldNobosscustomjs extends JFormFieldTextarea{
    protected $type = "nobosscustomjs";

    protected function getInput(){
        // seta o placeholder
        $this->hint = JText::_('NOBOSS_EXTENSIONS_JS_OVERWRITE_PLACEHOLDER');

        $this->class = "nb-custom-editor-js";
        
        $this->description = str_replace('#class_name#', ".{$this->element['class_name']}", JText::_('NOBOSS_EXTENSIONS_JS_OVERWRITE_DESC'));

        $doc = JFactory::getDocument();
        $doc->addStylesheet(JURI::root()."libraries/noboss/forms/fields/assets/stylesheets/css/nobosscustomjs.min.css");
        $doc->addScript(JURI::root()."libraries/noboss/forms/fields/assets/js/min/nobosscustomjs.min.js");

        return parent::getInput();
    }  

}
